Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/Job_mpi
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/Job_mpi	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/Job_mpi	(revision 3938)
@@ -7,5 +7,4 @@
 # Type de travail
 # @ job_type = parallel
-# @ as_limit = 7.0Gb
 # Fichier de sortie standard
 # @ output = Script_Output
@@ -13,6 +12,6 @@
 # @ error = error
 # Nombre de processus demandes
-# @ total_tasks =  30
-# @ environment = "BATCH_NUM_PROC_TOT=30"
+# @ total_tasks = 24 
+# @ environment = "BATCH_NUM_PROC_TOT=24"
 # Temps CPU max. par processus MPI hh:mm:ss
 # @ wall_clock_limit = 4:30:00
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/xmlio_server.def
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/xmlio_server.def	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/xmlio_server.def	(revision 3938)
@@ -30,5 +30,5 @@
                               !  setting nn_nchunks_k = jpk will give a chunk size of 1 in the vertical which
                               !  is optimal for postprocessing which works exclusively with horizontal slabs
-   ln_nc4zip      =   .TRUE.  !  (T) use netcdf4 chunking and compression
+   ln_nc4zip      =   .FALSE.  !  (T) use netcdf4 chunking and compression
                               !  (F) ignore chunking information and produce netcdf3-compatible files  
 /
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 3938)
@@ -187,4 +187,5 @@
    REAL(wp), PUBLIC ::   alphaevp = 1._wp      !: coeficient of the internal stresses !SB
    REAL(wp), PUBLIC ::   unit_fac = 1.e+09_wp  !: conversion factor for ice / snow enthalpy
+   REAL(wp), PUBLIC ::   hminrhg = 0.05_wp     !: clem : ice thickness (in m) below which ice velocity is set to ocean velocity
 
    !                                              !!** ice-salinity namelist (namicesal) **
@@ -393,14 +394,13 @@
    LOGICAL               , PUBLIC ::   ln_limdyn     = .TRUE.             !: flag for ice dynamics (T) or not (F)
    LOGICAL               , PUBLIC ::   ln_nicep      = .TRUE.             !: flag for sea-ice points output (T) or not (F)
-   REAL(wp)              , PUBLIC ::   hsndif        = 0.e0               !: computation of temp. in snow (0) or not (9999)
-   REAL(wp)              , PUBLIC ::   hicdif        = 0.e0               !: computation of temp. in ice (0) or not (9999)
    REAL(wp)              , PUBLIC ::   cai           = 1.40e-3            !: atmospheric drag over sea ice
    REAL(wp)              , PUBLIC ::   cao           = 1.00e-3            !: atmospheric drag over ocean
-   REAL(wp), DIMENSION(2), PUBLIC ::   acrit  = (/ 1.e-06 , 1.e-06 /)     !: minimum fraction for leads in
-   !                                                                      !: north and south hemisphere
+   REAL(wp)              , PUBLIC ::   amax          = 0.99               !: maximum ice concentration
+   !                                                                      !
    !!--------------------------------------------------------------------------
    !! * Ice diagnostics
    !!--------------------------------------------------------------------------
    !! Check if everything down here is necessary
+   LOGICAL , PUBLIC                                      ::   ln_limdiahsb  = .TRUE. !: flag for ice diag (T) or not (F)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   v_newice   !: volume of ice formed in the leads
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dv_dt_thd  !: thermodynamic growth rates 
@@ -412,4 +412,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   diag_bot_me   ! vertical bottom melt 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   diag_sur_me   ! vertical surface melt
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   diag_res_pr   ! production (growth+melt) due to limupdate
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   diag_trp_vi   ! transport of ice volume
    INTEGER , PUBLIC ::   jiindx, jjindx        !: indexes of the debugging point
 
@@ -460,5 +462,5 @@
 
       ii = ii + 1
-      ALLOCATE( patho_case(jpi, jpj, jpl)  , STAT=ierr(ii) )
+      ALLOCATE( patho_case(jpi,jpj,jpl) , STAT=ierr(ii) )
 
       ! * Ice global state variables
@@ -524,5 +526,5 @@
          &      izero    (jpi,jpj,jpl) , diag_bot_gr(jpi,jpj) , diag_dyn_gr(jpi,jpj) ,     &
          &      fstroc   (jpi,jpj,jpl) , diag_bot_me(jpi,jpj) , diag_sur_me(jpi,jpj) ,     &
-         &      fhbricat (jpi,jpj,jpl) , v_newice   (jpi,jpj)                        , STAT=ierr(ii) )
+         &      fhbricat (jpi,jpj,jpl) , diag_res_pr(jpi,jpj) , diag_trp_vi(jpi,jpj) , v_newice(jpi,jpj) , STAT=ierr(ii) )
 
       ice_alloc = MAXVAL( ierr(:) )
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/iceini.F90	(revision 3938)
@@ -124,5 +124,5 @@
       !! ** input   :   Namelist namicerun
       !!-------------------------------------------------------------------
-      NAMELIST/namicerun/ cn_icerst_in, cn_icerst_out, ln_limdyn, acrit, hsndif, hicdif, cai, cao, ln_nicep
+      NAMELIST/namicerun/ cn_icerst_in, cn_icerst_out, ln_limdyn, amax, cai, cao, ln_nicep, ln_limdiahsb
       !!-------------------------------------------------------------------
       !                    
@@ -140,10 +140,9 @@
          WRITE(numout,*) ' ~~~~~~'
          WRITE(numout,*) '   switch for ice dynamics (1) or not (0)      ln_limdyn   = ', ln_limdyn
-         WRITE(numout,*) '   minimum fraction for leads in the NH (SH)  acrit(1/2)   = ', acrit(:)
-         WRITE(numout,*) '   computation of temp. in snow (=0) or not (=9999) hsndif = ', hsndif
-         WRITE(numout,*) '   computation of temp. in ice  (=0) or not (=9999) hicdif = ', hicdif
+         WRITE(numout,*) '   maximum ice concentration                               = ', amax 
          WRITE(numout,*) '   atmospheric drag over sea ice                           = ', cai
          WRITE(numout,*) '   atmospheric drag over ocean                             = ', cao
          WRITE(numout,*) '   Several ice points in the ice or not in ocean.output    = ', ln_nicep
+         WRITE(numout,*) '   Diagnose heat/salt budget or not          ln_limdiahsb  = ', ln_limdiahsb
       ENDIF
       !
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limadv.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limadv.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limadv.F90	(revision 3938)
@@ -23,4 +23,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -88,5 +89,5 @@
             zs2new  = MIN(  2.0 * zslpmax - 0.3334 * ABS( zs1new ),      &
                &            MAX( ABS( zs1new ) - zslpmax, psxx(ji,jj) )  )
-            zin0    = ( 1.0 - MAX( rzero, sign ( rone, -zslpmax) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
+            zin0    = ( 1.0 - MAX( rzero, SIGN ( rone, -zslpmax ) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
 
             ps0 (ji,jj) = zslpmax  
@@ -273,5 +274,5 @@
             zs2new  = MIN(  ( 2.0 * zslpmax - 0.3334 * ABS( zs1new ) ),   &
                &             MAX( ABS( zs1new )-zslpmax, psyy(ji,jj) )  )
-            zin0    = ( 1.0 - MAX( rzero, sign ( rone, -zslpmax) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
+            zin0    = ( 1.0 - MAX( rzero, SIGN ( rone, -zslpmax ) ) ) * tms(ji,jj)   ! Case of empty boxes & Apply mask
             !
             ps0 (ji,jj) = zslpmax  
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdia.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdia.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdia.F90	(revision 3938)
@@ -23,4 +23,5 @@
    USE in_out_manager  ! I/O manager
    USE lib_mpp         ! MPP library
+   USE lib_fortran     ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
    
    IMPLICIT NONE
@@ -43,4 +44,5 @@
    INTEGER  ::   naveg               ! number of step for accumulation before averaging
    REAL(wp) ::   epsi06 = 1.e-6_wp   ! small number
+   REAL(wp) ::   epsi20 = 1.e-20_wp  ! small number
 
    CHARACTER(len= 8) ::   fmtinf = '1PE13.5 '   ! format of the output values  
@@ -70,14 +72,16 @@
       !!              the temporal evolution of some key variables
       !!-------------------------------------------------------------------
-      INTEGER  ::   jv, ji, jj, jl   ! dummy loop indices
-      REAL(wp) ::   zshift_date      ! date from the minimum ice extent
-      REAL(wp) ::   zday, zday_min   ! current day, day of minimum extent
-      REAL(wp) ::   zafy, zamy       ! temporary area of fy and my ice
+      INTEGER  ::   jv, ji, jj, jl       ! dummy loop indices
+      INTEGER  ::   ii0, ii1, ij0, ij1   ! temporary integer
+      REAL(wp) ::   zshift_date          ! date from the minimum ice extent
+      REAL(wp) ::   zday, zday_min       ! current day, day of minimum extent
+      REAL(wp) ::   zafy, zamy           ! temporary area of fy and my ice
       REAL(wp) ::   zindb
-      REAL(wp), DIMENSION(jpinfmx) ::   vinfor           ! temporary working space 
+      REAL(wp), DIMENSION(jpinfmx) ::   vinfor   ! 1D workspace 
       !!-------------------------------------------------------------------
 
       ! 0) date from the minimum of ice extent
       !---------------------------------------
+      !RETURN ! use this for debugging
       zday_min = 273._wp        ! zday_min = date of minimum extent, here September 30th
       zday = REAL(numit-nit000,wp) * rdt_ice / ( 86400._wp * REAL(nn_fsbc,wp) )
@@ -112,5 +116,5 @@
                ! the computation of this diagnostic is not reliable
                vinfor(31) = vinfor(31) + vt_i(ji,jj)*( u_ice(ji,jj)*u_ice(ji,jj) + & 
-                  v_ice(ji,jj)*v_ice(ji,jj) )*aire(ji,jj)/1.0e12 
+                  v_ice(ji,jj)*v_ice(ji,jj) )*aire(ji,jj) * 1.e-12 
                vinfor(53) = vinfor(53) + emps(ji,jj)*aire(ji,jj) * 1.e-12_wp !salt flux
                vinfor(55) = vinfor(55) + fsbri(ji,jj)*aire(ji,jj) * 1.e-12_wp !brine drainage flux
@@ -153,9 +157,9 @@
       vinfor(79) = vinfor(79) / MAX(vinfor(5),epsi06) !
 
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(3))) !
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(3)+epsi20)) !
       vinfor(59) = zindb*vinfor(59) / MAX(vinfor(3),epsi06) ! divide by ice area
       vinfor(61) = zindb*vinfor(61) / MAX(vinfor(3),epsi06) !
 
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(9))) !
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(9)+epsi20)) !
       vinfor(65) = zindb*vinfor(65) / MAX(vinfor(9),epsi06) ! divide it by snow volume
 
@@ -226,23 +230,25 @@
          END DO
       END DO
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(25))) !=0 if no multiyear ice 1 if yes
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(25)+epsi20)) !=0 if no multiyear ice 1 if yes
       vinfor(49) = zindb*vinfor(49) / MAX(vinfor(25),epsi06)
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(27))) !=0 if no multiyear ice 1 if yes
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(27)+epsi20)) !=0 if no multiyear ice 1 if yes
       vinfor(51) = zindb*vinfor(51) / MAX(vinfor(27),epsi06)
 
-      !! Fram Strait Export
-      !! 83 = area export
-      !! 84 = volume export
-      !! Fram strait in ORCA2 = 5 points
-      !! export = -v_ice*e1t*ddtb*at_i or -v_ice*e1t*ddtb*at_i*h_i
-      jj = 136 ! C grid
-      vinfor(83) = 0.0
-      vinfor(84) = 0.0
-      DO ji = 134, 138
-         vinfor(83) = vinfor(83) - v_ice(ji,jj) * & 
-            e1t(ji,jj)*at_i(ji,jj)*rdt_ice * 1.e-12_wp
-         vinfor(84) = vinfor(84) - v_ice(ji,jj) * & 
-            e1t(ji,jj)*vt_i(ji,jj)*rdt_ice * 1.e-12_wp
-      END DO
+      IF( cp_cfg == "orca" ) THEN   !* ORCA configuration : Fram Strait Export
+         SELECT CASE ( jp_cfg )
+         CASE ( 2 )                          ! ORCA_R2
+            ij0 = 136   ;   ij1 = 136              ! Fram strait : 83 = area export
+            ii0 = 134   ;   ii1 = 138              !               84 = volume export
+            DO jj = mj0(ij0),mj1(ij1)
+               DO ji = mi0(ii0),mi1(ii1)
+                  vinfor(83) = vinfor(83) - v_ice(ji,jj) * e1t(ji,jj)*at_i(ji,jj)*rdt_ice * 1.e-12_wp
+                  vinfor(84) = vinfor(84) - v_ice(ji,jj) * e1t(ji,jj)*vt_i(ji,jj)*rdt_ice * 1.e-12_wp
+               END DO
+            END DO
+         END SELECT
+!!gm   just above, this is NOT the correct way of evaluating the transport !
+!!gm        mass of snow is missing and v_ice should be the mean between jj and jj+1
+!!gm   Other ORCA configurations should be added
+      ENDIF
 
       !!-------------------------------------------------------------------
@@ -264,7 +270,9 @@
                vinfor(32) = vinfor(32) + vt_i(ji,jj)*( u_ice(ji,jj)*u_ice(ji,jj) + & 
                   v_ice(ji,jj)*v_ice(ji,jj) )*aire(ji,jj)/1.0e12 !ice vel
+!!gm  error??  multiplication by at_i seem wrong here....
                vinfor(54) = vinfor(54) + at_i(ji,jj)*emps(ji,jj)*aire(ji,jj) * 1.e-12_wp ! Total salt flux
                vinfor(56) = vinfor(56) + at_i(ji,jj)*fsbri(ji,jj)*aire(ji,jj) * 1.e-12_wp ! Brine drainage salt flux
                vinfor(58) = vinfor(58) + at_i(ji,jj)*fseqv(ji,jj)*aire(ji,jj) * 1.e-12_wp ! Equivalent salt flux
+!!gm end
                vinfor(60) = vinfor(60) +(sst_m(ji,jj)+rt0)*at_i(ji,jj)*aire(ji,jj) * 1.e-12_wp  !SST
                vinfor(62) = vinfor(62) + sss_m(ji,jj)*at_i(ji,jj)*aire(ji,jj) * 1.e-12_wp  !SSS
@@ -292,5 +300,5 @@
       vinfor(14) = 0.0
 
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(8))) 
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(8)+epsi20)) 
       vinfor(16) = zindb * vinfor(16) / MAX(vinfor(8),epsi06) ! these have to be divided by ice vol
       vinfor(30) = zindb * vinfor(30) / MAX(vinfor(8),epsi06) ! 
@@ -298,5 +306,5 @@
       vinfor(68) = zindb * vinfor(68) / MAX(vinfor(8),epsi06) ! 
 
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(6))) 
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(6)+epsi20)) 
       vinfor(54) = zindb * vinfor(54) / MAX(vinfor(6),epsi06) ! these have to be divided by ice extt
       vinfor(56) = zindb * vinfor(56) / MAX(vinfor(6),epsi06) ! 
@@ -305,9 +313,9 @@
       !      vinfor(84) = vinfor(84) / vinfor(6) !
 
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(4))) !
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(4)+epsi20)) !
       vinfor(60) = zindb*vinfor(60) / ( MAX(vinfor(4), epsi06) ) ! divide by ice area
       vinfor(62) = zindb*vinfor(62) / ( MAX(vinfor(4), epsi06) ) !
 
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(10))) !
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(10)+epsi20)) !
       vinfor(66) = zindb*vinfor(66) / MAX(vinfor(10),epsi06) ! divide it by snow volume
 
@@ -345,5 +353,5 @@
          END DO
       END DO
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(4))) !
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(4)+epsi20)) !
       vinfor(64) = zindb * vinfor(64) / MAX(vinfor(4),epsi06) ! divide by ice extt
       !! 2.2) Diagnostics dependent on age
@@ -377,7 +385,7 @@
          END DO ! jj
       END DO ! ji
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(26))) !=0 if no multiyear ice 1 if yes
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(26)+epsi20)) !=0 if no multiyear ice 1 if yes
       vinfor(50) = zindb*vinfor(50) / MAX(vinfor(26),epsi06)
-      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(28))) !=0 if no multiyear ice 1 if yes
+      zindb      = 1.0 - MAX(0.0,SIGN(1.0,-vinfor(28)+epsi20)) !=0 if no multiyear ice 1 if yes
       vinfor(52) = zindb*vinfor(52) / MAX(vinfor(28),epsi06)
 
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdiahsb.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdiahsb.F90	(revision 3938)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdiahsb.F90	(revision 3938)
@@ -0,0 +1,229 @@
+MODULE limdiahsb
+   !!======================================================================
+   !!                       ***  MODULE limdia_hsb   ***
+   !!  LIM-3 sea ice model :   diagnostics of ice model 
+   !!======================================================================
+   !! History :  3.4  ! 2012-10  (C. Rousset)  original code
+   !!----------------------------------------------------------------------
+#if defined key_lim3
+   !!----------------------------------------------------------------------
+   !!   'key_lim3'                                       LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   lim_dia_hsb        : computation and output of the time evolution of keys variables
+   !!   lim_dia_hsb_init   : initialization and namelist read
+   !!----------------------------------------------------------------------
+   USE ice             ! LIM-3: sea-ice variable
+   USE par_ice         ! LIM-3: ice parameters
+   USE dom_ice         ! LIM-3: sea-ice domain
+   USE dom_oce         ! ocean domain
+   USE sbc_oce         ! surface boundary condition: ocean fields
+   USE daymod          ! model calendar
+   USE phycst          ! physical constant
+   USE in_out_manager  ! I/O manager
+   USE lib_mpp         ! MPP library
+   USE timing          ! preformance summary
+   USE iom             ! I/O manager
+   USE lib_fortran     ! glob_sum
+   USE limrst          ! ice restart
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   lim_diahsb        ! routine called by ice_step.F90
+   !!PUBLIC   lim_diahsb_init   ! routine called by ice_init.F90
+   !!PUBLIC   lim_diahsb_rst   ! routine called by ice_init.F90
+
+   REAL(wp), SAVE   ::   frc_sal, frc_vol   ! global forcing trends
+   REAL(wp), SAVE   ::   bg_grpme           ! global ice growth+melt trends
+   REAL(wp) ::   epsi06 = 1.e-6_wp  ! small number
+   REAL(wp) ::   epsi03 = 1.e-3_wp  ! small number
+
+
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.4 , NEMO Consortium (2012)
+   !! $Id: limdiahsb.F90 3294 2012-10-18 16:44:18Z rblod $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE lim_diahsb
+      !!---------------------------------------------------------------------------
+      !!                  ***  ROUTINE lim_diahsb  ***
+      !!     
+      !! ** Purpose: Compute the ice global heat content, salt content and volume conservation
+      !!	
+      !! ** Method : - Compute the deviation of heat content, salt content and volume
+      !!	            at the current time step from their values at nit000
+      !!	            - Compute the contribution of forcing and remove it from these deviations
+      !!
+      !!---------------------------------------------------------------------------
+      !!
+      REAL(wp)   ::   zbg_ivo, zbg_svo, zbg_are, zbg_sal ,zbg_tem ,zbg_ihc ,zbg_shc
+      REAL(wp)   ::   zbg_emps, zbg_emp, zbg_fsbri, zbg_fseqv, zbg_fsalt_res, zbg_fsalt_rpo 
+      REAL(wp)   ::   z_frc_vol, z_frc_sal, z_bg_grpme 
+      REAL(wp)   ::   zdeltat, z1_area                     !    -     -
+      !!---------------------------------------------------------------------------
+      IF( nn_timing == 1 )   CALL timing_start('lim_diahsb')
+
+      IF( numit == nstart ) CALL lim_diahsb_init 
+
+      ! 1/area
+      z1_area = 1.0 / MAX( glob_sum( area(:,:) * tms(:,:) ),epsi06 )
+      ! ----------------------- !
+      ! 1 -  Content variations !
+      ! ----------------------- !
+      zbg_ivo = glob_sum( vt_i(:,:) * area(:,:) * tms(:,:) ) ! volume ice 
+      zbg_svo = glob_sum( vt_s(:,:) * area(:,:) * tms(:,:) ) ! volume snow
+      zbg_are = glob_sum( at_i(:,:) * area(:,:) * tms(:,:) ) ! area
+      zbg_sal = glob_sum( SUM(smv_i(:,:,:),dim=3) * area(:,:) * tms(:,:) ) ! mean salt content
+      zbg_tem = glob_sum( (tm_i(:,:)-rtt) * vt_i(:,:) * area(:,:) * tms(:,:) )  ! mean temp content
+
+      !zbg_ihc = glob_sum( et_i(:,:) * area(:,:) * tms(:,:) ) / MAX( zbg_ivo,epsi06 ) ! ice heat content
+      !zbg_shc = glob_sum( et_s(:,:) * area(:,:) * tms(:,:) ) / MAX( zbg_svo,epsi06 ) ! snow heat content
+
+      zbg_ihc = glob_sum( et_i(:,:) ) ! ice heat content  [10^9 J]
+      zbg_shc = glob_sum( et_s(:,:) ) ! snow heat content [10^9 J]
+
+      zbg_emps      = glob_sum(      emps(:,:) * area(:,:) * tms(:,:) ) * z1_area
+      zbg_emp       = glob_sum(       emp(:,:) * area(:,:) * tms(:,:) ) * z1_area
+      zbg_fsbri     = glob_sum(     fsbri(:,:) * area(:,:) * tms(:,:) ) * z1_area
+      zbg_fseqv     = glob_sum(     fseqv(:,:) * area(:,:) * tms(:,:) ) * z1_area
+      zbg_fsalt_res = glob_sum( fsalt_res(:,:) * area(:,:) * tms(:,:) ) * z1_area
+      zbg_fsalt_rpo = glob_sum( fsalt_rpo(:,:) * area(:,:) * tms(:,:) ) * z1_area
+      
+      ! --------------------------------------------- !
+      ! 2 - Trends due to forcing and ice growth/melt !
+      ! --------------------------------------------- !
+      z_frc_vol = ( 1.e0 / rau0 ) * glob_sum( - emp(:,:) * area(:,:) * tms(:,:) ) ! volume fluxes
+      z_frc_sal = ( 1.e0 / rau0 ) * glob_sum(  emps(:,:) * area(:,:) * tms(:,:) ) ! salt fluxes
+      z_bg_grpme = glob_sum( ( diag_bot_gr(:,:) + diag_lat_gr(:,:) + diag_sni_gr(:,:) + diag_dyn_gr(:,:) + &
+                          &    diag_bot_me(:,:) + diag_sur_me(:,:) + diag_res_pr(:,:) ) * area(:,:) * tms(:,:) ) ! volume fluxes
+      !
+      frc_vol  = frc_vol  + z_frc_vol  * rdt_ice
+      frc_sal  = frc_sal  + z_frc_sal  * rdt_ice
+      bg_grpme = bg_grpme + z_bg_grpme * rdt_ice
+      
+      ! difference
+      !frc_vol = zbg_ivo - frc_vol
+      !frc_sal = zbg_sal - frc_sal
+      
+      ! ----------------------- !
+      ! 3 - Diagnostics writing !
+      ! ----------------------- !
+      !zdeltat  = 1.e0 / ( ( kt - nit000 + 1 ) * rdt_ice )
+      !
+      CALL iom_put( 'ibgvoltot',zbg_ivo * rhoic / rau0 * 1.e-9 ) ! m3 (equivalent liquid)         
+      CALL iom_put( 'sbgvoltot',zbg_svo * rhosn / rau0 * 1.e-9 )  ! m3 (equivalent liquid)       
+      CALL iom_put( 'ibgarea',zbg_are * 1.e-6 )         
+      CALL iom_put( 'ibgsaline',zbg_sal / MAX( zbg_ivo,epsi03 ) )         
+      CALL iom_put( 'ibgtemper',zbg_tem / MAX( zbg_ivo,epsi03 ) )         
+      CALL iom_put( 'ibgheatco',zbg_ihc )           ! 10^9 J        
+      CALL iom_put( 'ibgsaltco',zbg_sal * rhoic / rau0 * 1.e-9 ) ! psu*km3        
+      CALL iom_put( 'sbgheatco',zbg_shc )           ! 10^9 J
+      CALL iom_put( 'ibgfrcemp',frc_vol * 1.e-9 )           !vol - forcing : km3 (equivalent liquid)         
+      CALL iom_put( 'ibgfrcemps',frc_sal * 1.e-9 )          !sal - forcing : psu*km3   
+      CALL iom_put( 'ibgemps',zbg_emps *86400)            
+      CALL iom_put( 'ibgemp',zbg_emp *86400)              
+      CALL iom_put( 'ibgfsbri',zbg_fsbri *86400)         
+      CALL iom_put( 'ibgfseqv',zbg_fseqv *86400)         
+      CALL iom_put( 'ibgfsaltres',zbg_fsalt_res *86400)         
+      CALL iom_put( 'ibgfsaltrpo',zbg_fsalt_rpo *86400)         
+      CALL iom_put( 'ibggrpme',bg_grpme * rhoic / rau0 * 1.e-9 ) ! km3 (equivalent liquid)         
+      !
+      IF( lrst_ice )   CALL lim_diahsb_rst( numit, 'WRITE' )
+      !
+      IF( nn_timing == 1 )   CALL timing_stop('lim_diahsb')
+!
+   END SUBROUTINE lim_diahsb
+
+
+   SUBROUTINE lim_diahsb_init
+      !!---------------------------------------------------------------------------
+      !!                  ***  ROUTINE lim_diahsb_init  ***
+      !!     
+      !! ** Purpose: Initialization for the heat salt volume budgets
+      !!	
+      !! ** Method : Compute initial heat content, salt content and volume
+      !!
+      !! ** Action : - Compute initial heat content, salt content and volume
+      !!             - Initialize forcing trends
+      !!             - Compute coefficients for conversion
+      !!---------------------------------------------------------------------------
+      INTEGER            ::   jk       ! dummy loop indice
+      INTEGER            ::   ierror   ! local integer
+      !!
+      !!NAMELIST/namicehsb/ blabla
+      !!----------------------------------------------------------------------
+      !
+      !!REWIND ( numnam_ice )              ! Read Namelist namicehsb 
+      !!READ   ( numnam_ice, namicehsb )
+      !
+      IF(lwp) THEN                   ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'lim_diahsb_init : check the heat and salt budgets'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+
+      ! ---------------------------------- !
+      ! 2 - initial conservation variables !
+      ! ---------------------------------- !
+      !frc_vol = 0._wp                                           ! volume       trend due to forcing
+      !frc_sal = 0._wp                                           ! salt content   -    -   -    -         
+      !bg_grpme = 0._wp                                          ! ice growth + melt volume trend
+      !
+      CALL lim_diahsb_rst( nstart, 'READ' )  !* read or initialize all required files
+      !
+   END SUBROUTINE lim_diahsb_init
+
+   SUBROUTINE lim_diahsb_rst( kt, cdrw )
+     !!---------------------------------------------------------------------
+     !!                   ***  ROUTINE limdia_rst  ***
+     !!                     
+     !! ** Purpose :   Read or write DIA file in restart file
+     !!
+     !! ** Method  :   use of IOM library
+     !!----------------------------------------------------------------------
+     INTEGER         , INTENT(in) ::   kt     ! ice time-step
+     CHARACTER(len=*), INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
+     !
+     INTEGER ::   id1, id2, id3   ! local integers
+     !!----------------------------------------------------------------------
+     !
+     IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialise 
+        IF( ln_rstart ) THEN                   !* Read the restart file
+           id1 = iom_varid( numrir, 'frc_vol'  , ldstop = .TRUE. )
+           !
+           CALL iom_get( numrir, 'frc_vol', frc_vol )
+           CALL iom_get( numrir, 'frc_sal', frc_sal )
+           CALL iom_get( numrir, 'bg_grpme', bg_grpme )
+       ELSE
+       	   frc_vol = 0._wp                                           
+       	   frc_sal = 0._wp                                                  
+      	   bg_grpme = 0._wp                                        
+       ENDIF	
+
+     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
+        !                                   ! -------------------
+        IF(lwp) WRITE(numout,*) '---- limdia-rst ----'
+        CALL iom_rstput( kt, nitrst, numriw, 'frc_vol'   , frc_vol     )
+        CALL iom_rstput( kt, nitrst, numriw, 'frc_sal'   , frc_sal     )
+        CALL iom_rstput( kt, nitrst, numriw, 'bg_grpme'  , bg_grpme     )
+        !
+     ENDIF
+     !
+   END SUBROUTINE lim_diahsb_rst
+ 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option :         Empty module          NO LIM sea-ice model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE lim_diahsb          ! Empty routine
+   END SUBROUTINE lim_diahsb
+#endif
+   !!======================================================================
+END MODULE limdiahsb
